#include <sourcemod>
#include <sdktools>


new Handle:cvarSnowOn = INVALID_HANDLE;
new Handle:cvarChoise;
new Handle:cvarDensity;


public Plugin:myinfo = 
{
    name = "Dod Weather",
    author = "andi67",
    description = "Change the Weather",
    version = "1.0",
    url = "http://www.andi67-blog.de.vu"
}

public OnPluginStart()
{
	cvarSnowOn = CreateConVar("dod_weather_on","1","Turns plugin on and off, 1=On ", FCVAR_NOTIFY);
	cvarChoise = CreateConVar("dod_weather_choise","2","0= Rain , 1= Ash , 2= Snow , 3= Snowfall",FCVAR_NOTIFY);
	cvarDensity = CreateConVar("dod_weather_density", "5", "Density of the precipitation(0-100%");	
	
	HookEvent("dod_round_start", Event_DodRoundStart); 
} 

public  Event_DodRoundStart(Handle:event, const String:name[], bool:dontBroadcast) 
{    
	if(GetConVarInt(cvarSnowOn) == 1)
	{
		decl String:choise[4];
		GetConVarString(cvarChoise, choise, sizeof(choise));
		
		decl String:density[100];
		GetConVarString(cvarDensity, density, sizeof(density));		
		
		decl String:MapName[128]; 
		decl String:buf[128]; 
		GetCurrentMap(MapName, sizeof(MapName)); 
		Format(buf, sizeof(buf), "maps/%s.bsp", MapName); 
		new ent = CreateEntityByName("func_precipitation"); 
		DispatchKeyValue(ent, "model", buf); 
		DispatchKeyValue(ent, "density", density);
		DispatchKeyValue(ent, "preciptype", choise); 
		DispatchSpawn(ent); 
		ActivateEntity(ent); 
		new Float:minbounds[3]; 
		GetEntPropVector(0, Prop_Data, "m_WorldMins", minbounds);  
		new Float:maxbounds[3]; 
		GetEntPropVector(0, Prop_Data, "m_WorldMaxs", maxbounds);      
     
		SetEntPropVector(ent, Prop_Send, "m_vecMins", minbounds); 
		SetEntPropVector(ent, Prop_Send, "m_vecMaxs", maxbounds);     
		new Float:m_vecOrigin[3]; 
		m_vecOrigin[0] = (minbounds[0] + maxbounds[0])/2; 
		m_vecOrigin[1] = (minbounds[1] + maxbounds[1])/2; 
		m_vecOrigin[2] = (minbounds[2] + maxbounds[2])/2; 
		TeleportEntity(ent, m_vecOrigin, NULL_VECTOR, NULL_VECTOR);
	}
}  

